<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!--NewPage-->
<HTML>
<HEAD>
<!-- Generated by javadoc (build 1.5.0_17) on Fri Dec 04 18:31:04 CET 2009 -->
<TITLE>
BasicLinAlgOperations
</TITLE>

<META NAME="keywords" CONTENT="ch.javasoft.math.linalg.BasicLinAlgOperations interface">

<LINK REL ="stylesheet" TYPE="text/css" HREF="../../../../stylesheet.css" TITLE="Style">

<SCRIPT type="text/javascript">
function windowTitle()
{
    parent.document.title="BasicLinAlgOperations";
}
</SCRIPT>
<NOSCRIPT>
</NOSCRIPT>

</HEAD>

<BODY BGCOLOR="white" onload="windowTitle();">


<!-- ========= START OF TOP NAVBAR ======= -->
<A NAME="navbar_top"><!-- --></A>
<A HREF="#skip-navbar_top" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_top_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="class-use/BasicLinAlgOperations.html"><FONT CLASS="NavBarFont1"><B>Use</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../index-files/index-1.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;PREV CLASS&nbsp;
&nbsp;<A HREF="../../../../ch/javasoft/math/linalg/DefaultBasicLinAlgOperations.html" title="class in ch.javasoft.math.linalg"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../index.html?ch/javasoft/math/linalg/BasicLinAlgOperations.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="BasicLinAlgOperations.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;NESTED&nbsp;|&nbsp;FIELD&nbsp;|&nbsp;CONSTR&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;FIELD&nbsp;|&nbsp;CONSTR&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_top"></A>
<!-- ========= END OF TOP NAVBAR ========= -->

<HR>
<!-- ======== START OF CLASS DATA ======== -->
<H2>
<FONT SIZE="-1">
ch.javasoft.math.linalg</FONT>
<BR>
Interface BasicLinAlgOperations&lt;N extends <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Number.html" title="class or interface in java.lang">Number</A>,A&gt;</H2>
<DL>
<DT><B>All Known Subinterfaces:</B> <DD><A HREF="../../../../ch/javasoft/math/linalg/LinAlgOperations.html" title="interface in ch.javasoft.math.linalg">LinAlgOperations</A>&lt;N,A&gt;</DD>
</DL>
<DL>
<DT><B>All Known Implementing Classes:</B> <DD><A HREF="../../../../ch/javasoft/math/linalg/DefaultBasicLinAlgOperations.html" title="class in ch.javasoft.math.linalg">DefaultBasicLinAlgOperations</A>, <A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="class in ch.javasoft.math.linalg">DefaultLinAlgOperations</A>, <A HREF="../../../../ch/javasoft/math/linalg/SupportBasicLinAlgOperations.html" title="class in ch.javasoft.math.linalg">SupportBasicLinAlgOperations</A></DD>
</DL>
<HR>
<DL>
<DT><PRE>public interface <A HREF="../../../../src-html/ch/javasoft/math/linalg/BasicLinAlgOperations.html#line.56"><B>BasicLinAlgOperations&lt;N extends <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Number.html" title="class or interface in java.lang">Number</A>,A&gt;</B></A></DL>
</PRE>

<P>
<code>LinAlgOperations</code> is a collection of arithmetic operations on 
 vectors and matrices as known from linear algebra. This interface only 
 defines basic functions such as addition, matrix multiplication or inner and
 outer product for vectors. For more complex functions, such as matrix 
 inversion or nullspace and rank computations, the extension 
 <A HREF="../../../../ch/javasoft/math/linalg/LinAlgOperations.html" title="interface in ch.javasoft.math.linalg"><CODE>LinAlgOperations</CODE></A> should be used instead.   
 <p>
 An instance of this class defines the (boxed) number type and the array type, 
 such as <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Double.html" title="class or interface in java.lang"><CODE>Double</CODE></A> and <code>double[]</code>.
<P>

<P>
<HR>

<P>

<!-- ========== METHOD SUMMARY =========== -->

<A NAME="method_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Method Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#abs(A)">abs</A></B>(<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&nbsp;vector)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a new vector where all elements are non-negative, negative values
 from the original vector have changed sign</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[]</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#abs(A[])">abs</A></B>(<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[]&nbsp;matrix)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a new matrix where all elements are non-negative, negative values
 from the original matrix have changed sign</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[]</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#add(A[], A[])">add</A></B>(<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[]&nbsp;m1,
       <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[]&nbsp;m2)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a new matrix where each element is the sum of the corresponding
 source matrix elements.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#add(A, A)">add</A></B>(<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&nbsp;v,
       <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&nbsp;u)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a new vector where each element is the sum of the corresponding
 source vector elements.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Class.html" title="class or interface in java.lang">Class</A>&lt;<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#arrayClass()">arrayClass</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the number type class of an array of values</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[]</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#divideElementByElement(A[], A[])">divideElementByElement</A></B>(<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[]&nbsp;m1,
                                             <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[]&nbsp;m2)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a new matrix where each element is the quotient of the 
 corresponding source matrix elements.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#divideElementByElement(A, A)">divideElementByElement</A></B>(<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&nbsp;v,
                                             <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&nbsp;u)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a new vector where each element is the quotient of the 
 corresponding source vector elements.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">N</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#get(A[], int, int)">get</A></B>(<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[]&nbsp;matrix,
       int&nbsp;row,
       int&nbsp;col)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a single element of the given matrix</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">N</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#get(A, int)">get</A></B>(<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&nbsp;vector,
       int&nbsp;index)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a single element of the given vector</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/array/ArrayOperations.html" title="interface in ch.javasoft.math.array">ArrayOperations</A>&lt;<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#getArrayOperations()">getArrayOperations</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the array operations, used to create, copy and handle vectors and
 matrices</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" SUMMARY="">
<TR ALIGN="right" VALIGN="">
<TD NOWRAP><FONT SIZE="-1">
<CODE>&lt;IN extends <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Number.html" title="class or interface in java.lang">Number</A>,IA&gt; 
<BR>
<A HREF="../../../../ch/javasoft/math/array/Converter.html" title="class in ch.javasoft.math.array">Converter</A>&lt;IN,IA,<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">N</A>,<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&gt;</CODE></FONT></TD>
</TR>
</TABLE>
</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#getConverterFrom(ch.javasoft.math.array.NumberArrayOperations)">getConverterFrom</A></B>(<A HREF="../../../../ch/javasoft/math/array/NumberArrayOperations.html" title="interface in ch.javasoft.math.array">NumberArrayOperations</A>&lt;IN,IA&gt;&nbsp;fromOps)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a converter that is able to convert matrices, vectors and numbers 
 of input type <code>IN</code> to the current type <code>N</code>.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" SUMMARY="">
<TR ALIGN="right" VALIGN="">
<TD NOWRAP><FONT SIZE="-1">
<CODE>&lt;RN extends <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Number.html" title="class or interface in java.lang">Number</A>,RA&gt; 
<BR>
<A HREF="../../../../ch/javasoft/math/array/Converter.html" title="class in ch.javasoft.math.array">Converter</A>&lt;<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">N</A>,<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>,RN,RA&gt;</CODE></FONT></TD>
</TR>
</TABLE>
</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#getConverterTo(ch.javasoft.math.array.NumberArrayOperations)">getConverterTo</A></B>(<A HREF="../../../../ch/javasoft/math/array/NumberArrayOperations.html" title="interface in ch.javasoft.math.array">NumberArrayOperations</A>&lt;RN,RA&gt;&nbsp;toOps)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a converter that is able to convert matrices, vectors and numbers 
 of the current type <code>N</code> to the result type <code>RN</code>.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/array/ExpressionComposer.html" title="class in ch.javasoft.math.array">ExpressionComposer</A>&lt;<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">N</A>,<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#getExpressionComposer()">getExpressionComposer</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the expression composer, used to compose arithmetic expressions</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/array/NumberArrayOperations.html" title="interface in ch.javasoft.math.array">NumberArrayOperations</A>&lt;<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">N</A>,<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#getNumberArrayOperations()">getNumberArrayOperations</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the number array operations, used to apply numeric operators to 
 vectors or matrices</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/array/NumberOperators.html" title="interface in ch.javasoft.math.array">NumberOperators</A>&lt;<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">N</A>,<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#getNumberOperators()">getNumberOperators</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the number operators for the number type of this operations</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#multiply(A[], A)">multiply</A></B>(<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[]&nbsp;m,
                 <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&nbsp;v)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the product of the matrix with the column vector using matrix 
 multiplication.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[]</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#multiply(A[], A[])">multiply</A></B>(<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[]&nbsp;m1,
                 <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[]&nbsp;m2)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the product of the two matrices using matrix multiplication.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#multiply(A, A[])">multiply</A></B>(<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&nbsp;v,
                 <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[]&nbsp;m)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the product of the row vector with the matrix using matrix 
 multiplication.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[]</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#multiplyElementByElement(A[], A[])">multiplyElementByElement</A></B>(<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[]&nbsp;m1,
                                                 <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[]&nbsp;m2)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a new matrix where each element is the product of the 
 corresponding source matrix elements.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#multiplyElementByElement(A, A)">multiplyElementByElement</A></B>(<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&nbsp;v,
                                                 <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&nbsp;u)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a new vector where each element is the product of the 
 corresponding source vector elements.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">N</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#multiplyInner(A, A)">multiplyInner</A></B>(<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&nbsp;v,
                           <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&nbsp;u)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a scalar representing the inner product of the two vectors.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[]</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#multiplyOuter(A, A)">multiplyOuter</A></B>(<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&nbsp;v,
                           <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&nbsp;u)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a matrix representing the outer product of the two vectors.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#negate(A)">negate</A></B>(<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&nbsp;vector)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a new vector where all elements are negated compared to the 
 original vector</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[]</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#negate(A[])">negate</A></B>(<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[]&nbsp;matrix)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a new matrix where all elements are negated compared to the 
 original matrix</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Class.html" title="class or interface in java.lang">Class</A>&lt;<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">N</A>&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#numberClass()">numberClass</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the number type class for a single value</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#signum(A[], int, int)">signum</A></B>(<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[]&nbsp;matrix,
             int&nbsp;row,
             int&nbsp;col)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the sign of a single element of the given matrix</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#signum(A, int)">signum</A></B>(<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&nbsp;vector,
             int&nbsp;index)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the sign of a single element of the given vector</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[]</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#subtract(A[], A[])">subtract</A></B>(<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[]&nbsp;m1,
                 <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[]&nbsp;m2)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a new matrix where each element is the difference of the 
 corresponding source matrix elements.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#subtract(A, A)">subtract</A></B>(<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&nbsp;v,
                 <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&nbsp;u)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a new vector where each element is the difference of the 
 corresponding source vector elements.</TD>
</TR>
</TABLE>
&nbsp;
<P>

<!-- ============ METHOD DETAIL ========== -->

<A NAME="method_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Method Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="numberClass()"><!-- --></A><H3>
numberClass</H3>
<PRE>
<A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Class.html" title="class or interface in java.lang">Class</A>&lt;<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">N</A>&gt; <A HREF="../../../../src-html/ch/javasoft/math/linalg/BasicLinAlgOperations.html#line.61"><B>numberClass</B></A>()</PRE>
<DL>
<DD>Returns the number type class for a single value
<P>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="arrayClass()"><!-- --></A><H3>
arrayClass</H3>
<PRE>
<A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Class.html" title="class or interface in java.lang">Class</A>&lt;<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&gt; <A HREF="../../../../src-html/ch/javasoft/math/linalg/BasicLinAlgOperations.html#line.66"><B>arrayClass</B></A>()</PRE>
<DL>
<DD>Returns the number type class of an array of values
<P>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getNumberArrayOperations()"><!-- --></A><H3>
getNumberArrayOperations</H3>
<PRE>
<A HREF="../../../../ch/javasoft/math/array/NumberArrayOperations.html" title="interface in ch.javasoft.math.array">NumberArrayOperations</A>&lt;<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">N</A>,<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&gt; <A HREF="../../../../src-html/ch/javasoft/math/linalg/BasicLinAlgOperations.html#line.72"><B>getNumberArrayOperations</B></A>()</PRE>
<DL>
<DD>Returns the number array operations, used to apply numeric operators to 
 vectors or matrices
<P>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getNumberOperators()"><!-- --></A><H3>
getNumberOperators</H3>
<PRE>
<A HREF="../../../../ch/javasoft/math/array/NumberOperators.html" title="interface in ch.javasoft.math.array">NumberOperators</A>&lt;<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">N</A>,<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&gt; <A HREF="../../../../src-html/ch/javasoft/math/linalg/BasicLinAlgOperations.html#line.77"><B>getNumberOperators</B></A>()</PRE>
<DL>
<DD>Returns the number operators for the number type of this operations
<P>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getArrayOperations()"><!-- --></A><H3>
getArrayOperations</H3>
<PRE>
<A HREF="../../../../ch/javasoft/math/array/ArrayOperations.html" title="interface in ch.javasoft.math.array">ArrayOperations</A>&lt;<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&gt; <A HREF="../../../../src-html/ch/javasoft/math/linalg/BasicLinAlgOperations.html#line.83"><B>getArrayOperations</B></A>()</PRE>
<DL>
<DD>Returns the array operations, used to create, copy and handle vectors and
 matrices
<P>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getConverterFrom(ch.javasoft.math.array.NumberArrayOperations)"><!-- --></A><H3>
getConverterFrom</H3>
<PRE>
&lt;IN extends <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Number.html" title="class or interface in java.lang">Number</A>,IA&gt; <A HREF="../../../../ch/javasoft/math/array/Converter.html" title="class in ch.javasoft.math.array">Converter</A>&lt;IN,IA,<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">N</A>,<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&gt; <A HREF="../../../../src-html/ch/javasoft/math/linalg/BasicLinAlgOperations.html#line.92"><B>getConverterFrom</B></A>(<A HREF="../../../../ch/javasoft/math/array/NumberArrayOperations.html" title="interface in ch.javasoft.math.array">NumberArrayOperations</A>&lt;IN,IA&gt;&nbsp;fromOps)</PRE>
<DL>
<DD>Returns a converter that is able to convert matrices, vectors and numbers 
 of input type <code>IN</code> to the current type <code>N</code>.
 <pre>
   converter(IN x) = convert x to N
 </pre>
<P>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getConverterTo(ch.javasoft.math.array.NumberArrayOperations)"><!-- --></A><H3>
getConverterTo</H3>
<PRE>
&lt;RN extends <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Number.html" title="class or interface in java.lang">Number</A>,RA&gt; <A HREF="../../../../ch/javasoft/math/array/Converter.html" title="class in ch.javasoft.math.array">Converter</A>&lt;<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">N</A>,<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>,RN,RA&gt; <A HREF="../../../../src-html/ch/javasoft/math/linalg/BasicLinAlgOperations.html#line.101"><B>getConverterTo</B></A>(<A HREF="../../../../ch/javasoft/math/array/NumberArrayOperations.html" title="interface in ch.javasoft.math.array">NumberArrayOperations</A>&lt;RN,RA&gt;&nbsp;toOps)</PRE>
<DL>
<DD>Returns a converter that is able to convert matrices, vectors and numbers 
 of the current type <code>N</code> to the result type <code>RN</code>.
 <pre>
   converter(N x) = convert x to RN
 </pre>
<P>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getExpressionComposer()"><!-- --></A><H3>
getExpressionComposer</H3>
<PRE>
<A HREF="../../../../ch/javasoft/math/array/ExpressionComposer.html" title="class in ch.javasoft.math.array">ExpressionComposer</A>&lt;<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">N</A>,<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&gt; <A HREF="../../../../src-html/ch/javasoft/math/linalg/BasicLinAlgOperations.html#line.106"><B>getExpressionComposer</B></A>()</PRE>
<DL>
<DD>Returns the expression composer, used to compose arithmetic expressions
<P>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="get(java.lang.Object,int)"><!-- --></A><A NAME="get(A, int)"><!-- --></A><H3>
get</H3>
<PRE>
<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">N</A> <A HREF="../../../../src-html/ch/javasoft/math/linalg/BasicLinAlgOperations.html#line.114"><B>get</B></A>(<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&nbsp;vector,
      int&nbsp;index)</PRE>
<DL>
<DD>Returns a single element of the given vector
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>vector</CODE> - the vector from which to return an element<DD><CODE>index</CODE> - the index in the matrix, zero based</DL>
</DD>
</DL>
<HR>

<A NAME="get(java.lang.Object,int,int)"><!-- --></A><A NAME="get(A[], int, int)"><!-- --></A><H3>
get</H3>
<PRE>
<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">N</A> <A HREF="../../../../src-html/ch/javasoft/math/linalg/BasicLinAlgOperations.html#line.123"><B>get</B></A>(<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[]&nbsp;matrix,
      int&nbsp;row,
      int&nbsp;col)</PRE>
<DL>
<DD>Returns a single element of the given matrix
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>matrix</CODE> - the matrix from which to return an element<DD><CODE>row</CODE> - the row index in the matrix, zero based<DD><CODE>col</CODE> - the column index in the matrix, zero based</DL>
</DD>
</DL>
<HR>

<A NAME="signum(java.lang.Object,int)"><!-- --></A><A NAME="signum(A, int)"><!-- --></A><H3>
signum</H3>
<PRE>
int <A HREF="../../../../src-html/ch/javasoft/math/linalg/BasicLinAlgOperations.html#line.132"><B>signum</B></A>(<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&nbsp;vector,
           int&nbsp;index)</PRE>
<DL>
<DD>Returns the sign of a single element of the given vector
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>vector</CODE> - the vector from which to return the sign of an element<DD><CODE>index</CODE> - the index in the matrix, zero based
<DT><B>Returns:</B><DD>-1, 0, 1 for a positive, zero, negative value</DL>
</DD>
</DL>
<HR>

<A NAME="signum(java.lang.Object,int,int)"><!-- --></A><A NAME="signum(A[], int, int)"><!-- --></A><H3>
signum</H3>
<PRE>
int <A HREF="../../../../src-html/ch/javasoft/math/linalg/BasicLinAlgOperations.html#line.142"><B>signum</B></A>(<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[]&nbsp;matrix,
           int&nbsp;row,
           int&nbsp;col)</PRE>
<DL>
<DD>Returns the sign of a single element of the given matrix
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>matrix</CODE> - the matrix from which to return the sign of an element<DD><CODE>row</CODE> - the row index in the matrix, zero based<DD><CODE>col</CODE> - the column index in the matrix, zero based
<DT><B>Returns:</B><DD>-1, 0, 1 for a positive, zero, negative value</DL>
</DD>
</DL>
<HR>

<A NAME="negate(java.lang.Object)"><!-- --></A><A NAME="negate(A)"><!-- --></A><H3>
negate</H3>
<PRE>
<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A> <A HREF="../../../../src-html/ch/javasoft/math/linalg/BasicLinAlgOperations.html#line.151"><B>negate</B></A>(<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&nbsp;vector)</PRE>
<DL>
<DD>Returns a new vector where all elements are negated compared to the 
 original vector
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>vector</CODE> - the vector to negate
<DT><B>Returns:</B><DD><code>-vector</code></DL>
</DD>
</DL>
<HR>

<A NAME="negate(java.lang.Object)"><!-- --></A><A NAME="negate(A[])"><!-- --></A><H3>
negate</H3>
<PRE>
<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[] <A HREF="../../../../src-html/ch/javasoft/math/linalg/BasicLinAlgOperations.html#line.160"><B>negate</B></A>(<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[]&nbsp;matrix)</PRE>
<DL>
<DD>Returns a new matrix where all elements are negated compared to the 
 original matrix
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>matrix</CODE> - the matrix to negate
<DT><B>Returns:</B><DD><code>-matrix</code></DL>
</DD>
</DL>
<HR>

<A NAME="abs(java.lang.Object)"><!-- --></A><A NAME="abs(A)"><!-- --></A><H3>
abs</H3>
<PRE>
<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A> <A HREF="../../../../src-html/ch/javasoft/math/linalg/BasicLinAlgOperations.html#line.169"><B>abs</B></A>(<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&nbsp;vector)</PRE>
<DL>
<DD>Returns a new vector where all elements are non-negative, negative values
 from the original vector have changed sign
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>vector</CODE> - the vector
<DT><B>Returns:</B><DD><code>abs(vector)</code></DL>
</DD>
</DL>
<HR>

<A NAME="abs(java.lang.Object)"><!-- --></A><A NAME="abs(A[])"><!-- --></A><H3>
abs</H3>
<PRE>
<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[] <A HREF="../../../../src-html/ch/javasoft/math/linalg/BasicLinAlgOperations.html#line.178"><B>abs</B></A>(<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[]&nbsp;matrix)</PRE>
<DL>
<DD>Returns a new matrix where all elements are non-negative, negative values
 from the original matrix have changed sign
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>matrix</CODE> - the matrix
<DT><B>Returns:</B><DD><code>abs(matrix)</code></DL>
</DD>
</DL>
<HR>

<A NAME="add(java.lang.Object,java.lang.Object)"><!-- --></A><A NAME="add(A, A)"><!-- --></A><H3>
add</H3>
<PRE>
<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A> <A HREF="../../../../src-html/ch/javasoft/math/linalg/BasicLinAlgOperations.html#line.191"><B>add</B></A>(<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&nbsp;v,
      <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&nbsp;u)</PRE>
<DL>
<DD>Returns a new vector where each element is the sum of the corresponding
 source vector elements. If the vectors have not the same length, an
 exception is thrown.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>v</CODE> - the first addend vector<DD><CODE>u</CODE> - the second addend vector
<DT><B>Returns:</B><DD><code>v + u</code>
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/IllegalArgumentException.html" title="class or interface in java.lang">IllegalArgumentException</A></CODE> - if the vectors have not the same length</DL>
</DD>
</DL>
<HR>

<A NAME="add(java.lang.Object,java.lang.Object)"><!-- --></A><A NAME="add(A[], A[])"><!-- --></A><H3>
add</H3>
<PRE>
<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[] <A HREF="../../../../src-html/ch/javasoft/math/linalg/BasicLinAlgOperations.html#line.204"><B>add</B></A>(<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[]&nbsp;m1,
        <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[]&nbsp;m2)</PRE>
<DL>
<DD>Returns a new matrix where each element is the sum of the corresponding
 source matrix elements. If the matrices have not equal dimensions, an
 exception is thrown.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>m1</CODE> - the first addend matrix<DD><CODE>m2</CODE> - the second addend matrix
<DT><B>Returns:</B><DD><code>m1 + m2</code>
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/IllegalArgumentException.html" title="class or interface in java.lang">IllegalArgumentException</A></CODE> - if the matrices have unequal dimensions</DL>
</DD>
</DL>
<HR>

<A NAME="subtract(java.lang.Object,java.lang.Object)"><!-- --></A><A NAME="subtract(A, A)"><!-- --></A><H3>
subtract</H3>
<PRE>
<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A> <A HREF="../../../../src-html/ch/javasoft/math/linalg/BasicLinAlgOperations.html#line.217"><B>subtract</B></A>(<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&nbsp;v,
           <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&nbsp;u)</PRE>
<DL>
<DD>Returns a new vector where each element is the difference of the 
 corresponding source vector elements. If the vectors have not the same 
 length, an exception is thrown.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>v</CODE> - the vector to subtract from<DD><CODE>u</CODE> - the vector to subtract
<DT><B>Returns:</B><DD><code>v - u</code>
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/IllegalArgumentException.html" title="class or interface in java.lang">IllegalArgumentException</A></CODE> - if the vectors have not the same length</DL>
</DD>
</DL>
<HR>

<A NAME="subtract(java.lang.Object,java.lang.Object)"><!-- --></A><A NAME="subtract(A[], A[])"><!-- --></A><H3>
subtract</H3>
<PRE>
<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[] <A HREF="../../../../src-html/ch/javasoft/math/linalg/BasicLinAlgOperations.html#line.230"><B>subtract</B></A>(<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[]&nbsp;m1,
             <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[]&nbsp;m2)</PRE>
<DL>
<DD>Returns a new matrix where each element is the difference of the 
 corresponding source matrix elements. If the matrices have not equal 
 dimensions, an exception is thrown.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>m1</CODE> - the matrix to subtract from<DD><CODE>m2</CODE> - the matrix to subtract
<DT><B>Returns:</B><DD><code>m1 - m2</code>
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/IllegalArgumentException.html" title="class or interface in java.lang">IllegalArgumentException</A></CODE> - if the matrices have unequal dimensions</DL>
</DD>
</DL>
<HR>

<A NAME="multiplyInner(java.lang.Object,java.lang.Object)"><!-- --></A><A NAME="multiplyInner(A, A)"><!-- --></A><H3>
multiplyInner</H3>
<PRE>
<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">N</A> <A HREF="../../../../src-html/ch/javasoft/math/linalg/BasicLinAlgOperations.html#line.244"><B>multiplyInner</B></A>(<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&nbsp;v,
                <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&nbsp;u)</PRE>
<DL>
<DD>Returns a scalar representing the inner product of the two vectors. This
 product is also known as dot or scalar product. If the vector have not 
 equal lengths, an exception is thrown.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>v</CODE> - the first vector<DD><CODE>u</CODE> - the second vector
<DT><B>Returns:</B><DD><code>&lt;v,u&gt; = u<sup>T</sup>v = 
                        &sum;(v[0]*u[0] + v[1]*u[1] + ... + v[n-1]*u[n-1])</code>
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/IllegalArgumentException.html" title="class or interface in java.lang">IllegalArgumentException</A></CODE> - if the vectors have not the same length</DL>
</DD>
</DL>
<HR>

<A NAME="multiplyElementByElement(java.lang.Object,java.lang.Object)"><!-- --></A><A NAME="multiplyElementByElement(A, A)"><!-- --></A><H3>
multiplyElementByElement</H3>
<PRE>
<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A> <A HREF="../../../../src-html/ch/javasoft/math/linalg/BasicLinAlgOperations.html#line.257"><B>multiplyElementByElement</B></A>(<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&nbsp;v,
                           <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&nbsp;u)</PRE>
<DL>
<DD>Returns a new vector where each element is the product of the 
 corresponding source vector elements. If the vector have not equal  
 lengths, an exception is thrown.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>v</CODE> - the first vector<DD><CODE>u</CODE> - the second vector
<DT><B>Returns:</B><DD><code>v .* u</code>
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/IllegalArgumentException.html" title="class or interface in java.lang">IllegalArgumentException</A></CODE> - if the vectors have not the same length</DL>
</DD>
</DL>
<HR>

<A NAME="multiplyOuter(java.lang.Object,java.lang.Object)"><!-- --></A><A NAME="multiplyOuter(A, A)"><!-- --></A><H3>
multiplyOuter</H3>
<PRE>
<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[] <A HREF="../../../../src-html/ch/javasoft/math/linalg/BasicLinAlgOperations.html#line.275"><B>multiplyOuter</B></A>(<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&nbsp;v,
                  <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&nbsp;u)</PRE>
<DL>
<DD>Returns a matrix representing the outer product of the two vectors. This
 product sometimes called tensor product of the vectors. If the vector 
 have not equal lengths, an exception is thrown.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>v</CODE> - the first vector<DD><CODE>u</CODE> - the second vector
<DT><B>Returns:</B><DD><pre>v &otimes; u = u v<sup>T</sup> = 
 [u1 v1 , u1 v2 , u1 v3 , ...]
 [u2 v1 , u2 v2 , u2 v3 , ...]
 [u3 v1 , u3 v2 , u3 v3 , ...]
 [             ...           ]
 </pre>
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/IllegalArgumentException.html" title="class or interface in java.lang">IllegalArgumentException</A></CODE> - if the vectors have not the same length</DL>
</DD>
</DL>
<HR>

<A NAME="multiplyElementByElement(java.lang.Object,java.lang.Object)"><!-- --></A><A NAME="multiplyElementByElement(A[], A[])"><!-- --></A><H3>
multiplyElementByElement</H3>
<PRE>
<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[] <A HREF="../../../../src-html/ch/javasoft/math/linalg/BasicLinAlgOperations.html#line.288"><B>multiplyElementByElement</B></A>(<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[]&nbsp;m1,
                             <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[]&nbsp;m2)</PRE>
<DL>
<DD>Returns a new matrix where each element is the product of the 
 corresponding source matrix elements. If the matrices have not equal 
 dimensions, an exception is thrown.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>m1</CODE> - the first matrix<DD><CODE>m2</CODE> - the second matrix
<DT><B>Returns:</B><DD><code>m1 .* m2</code>
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/IllegalArgumentException.html" title="class or interface in java.lang">IllegalArgumentException</A></CODE> - if the matrices have unequal dimensions</DL>
</DD>
</DL>
<HR>

<A NAME="multiply(java.lang.Object,java.lang.Object)"><!-- --></A><A NAME="multiply(A[], A[])"><!-- --></A><H3>
multiply</H3>
<PRE>
<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[] <A HREF="../../../../src-html/ch/javasoft/math/linalg/BasicLinAlgOperations.html#line.302"><B>multiply</B></A>(<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[]&nbsp;m1,
             <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[]&nbsp;m2)</PRE>
<DL>
<DD>Returns the product of the two matrices using matrix multiplication. If 
 the number of columns of the first matrix is not equal to the number of 
 rows of the second matrix, an exception is thrown.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>m1</CODE> - the first matrix<DD><CODE>m2</CODE> - the second matrix
<DT><B>Returns:</B><DD><code>m1 * m2</code>
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/IllegalArgumentException.html" title="class or interface in java.lang">IllegalArgumentException</A></CODE> - if the dimensions of the matrices are 
                                                                        not compatible for matrix multiplication</DL>
</DD>
</DL>
<HR>

<A NAME="multiply(java.lang.Object,java.lang.Object)"><!-- --></A><A NAME="multiply(A[], A)"><!-- --></A><H3>
multiply</H3>
<PRE>
<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A> <A HREF="../../../../src-html/ch/javasoft/math/linalg/BasicLinAlgOperations.html#line.317"><B>multiply</B></A>(<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[]&nbsp;m,
           <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&nbsp;v)</PRE>
<DL>
<DD>Returns the product of the matrix with the column vector using matrix 
 multiplication. Input and output vector are interpreted as column 
 vectors. If the number of columns of the matrix is not equal to the 
 length of the vector, an exception is thrown.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>m</CODE> - the matrix<DD><CODE>v</CODE> - the vector
<DT><B>Returns:</B><DD><code>m * v</code>
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/IllegalArgumentException.html" title="class or interface in java.lang">IllegalArgumentException</A></CODE> - if the number of columns in <code>m</code> is 
                                                                        not equal to the length of <code>v</code></DL>
</DD>
</DL>
<HR>

<A NAME="multiply(java.lang.Object,java.lang.Object)"><!-- --></A><A NAME="multiply(A, A[])"><!-- --></A><H3>
multiply</H3>
<PRE>
<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A> <A HREF="../../../../src-html/ch/javasoft/math/linalg/BasicLinAlgOperations.html#line.332"><B>multiply</B></A>(<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&nbsp;v,
           <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[]&nbsp;m)</PRE>
<DL>
<DD>Returns the product of the row vector with the matrix using matrix 
 multiplication. Input and output vector are interpreted as row 
 vectors. If the number of rows of the matrix is not equal to the 
 length of the vector, an exception is thrown.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>v</CODE> - the vector<DD><CODE>m</CODE> - the matrix
<DT><B>Returns:</B><DD><code>v * m</code>
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/IllegalArgumentException.html" title="class or interface in java.lang">IllegalArgumentException</A></CODE> - if the number of rows in <code>m</code> is 
                                                                        not equal to the length of <code>v</code></DL>
</DD>
</DL>
<HR>

<A NAME="divideElementByElement(java.lang.Object,java.lang.Object)"><!-- --></A><A NAME="divideElementByElement(A, A)"><!-- --></A><H3>
divideElementByElement</H3>
<PRE>
<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A> <A HREF="../../../../src-html/ch/javasoft/math/linalg/BasicLinAlgOperations.html#line.345"><B>divideElementByElement</B></A>(<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&nbsp;v,
                         <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>&nbsp;u)</PRE>
<DL>
<DD>Returns a new vector where each element is the quotient of the 
 corresponding source vector elements. If the vector have not equal  
 lengths, an exception is thrown.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>v</CODE> - the dividend vector<DD><CODE>u</CODE> - the divisor vector
<DT><B>Returns:</B><DD><code>v ./ u</code>
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/IllegalArgumentException.html" title="class or interface in java.lang">IllegalArgumentException</A></CODE> - if the matrices have unequal dimensions</DL>
</DD>
</DL>
<HR>

<A NAME="divideElementByElement(java.lang.Object,java.lang.Object)"><!-- --></A><A NAME="divideElementByElement(A[], A[])"><!-- --></A><H3>
divideElementByElement</H3>
<PRE>
<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[] <A HREF="../../../../src-html/ch/javasoft/math/linalg/BasicLinAlgOperations.html#line.358"><B>divideElementByElement</B></A>(<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[]&nbsp;m1,
                           <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="type parameter in BasicLinAlgOperations">A</A>[]&nbsp;m2)</PRE>
<DL>
<DD>Returns a new matrix where each element is the quotient of the 
 corresponding source matrix elements. If the matrices have not equal 
 dimensions, an exception is thrown.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>m1</CODE> - the dividend matrix<DD><CODE>m2</CODE> - the divisor matrix
<DT><B>Returns:</B><DD><code>m1 ./ m2</code>
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/IllegalArgumentException.html" title="class or interface in java.lang">IllegalArgumentException</A></CODE> - if the matrices have unequal dimensions</DL>
</DD>
</DL>
<!-- ========= END OF CLASS DATA ========= -->
<HR>


<!-- ======= START OF BOTTOM NAVBAR ====== -->
<A NAME="navbar_bottom"><!-- --></A>
<A HREF="#skip-navbar_bottom" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_bottom_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="class-use/BasicLinAlgOperations.html"><FONT CLASS="NavBarFont1"><B>Use</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../index-files/index-1.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;PREV CLASS&nbsp;
&nbsp;<A HREF="../../../../ch/javasoft/math/linalg/DefaultBasicLinAlgOperations.html" title="class in ch.javasoft.math.linalg"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../index.html?ch/javasoft/math/linalg/BasicLinAlgOperations.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="BasicLinAlgOperations.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;NESTED&nbsp;|&nbsp;FIELD&nbsp;|&nbsp;CONSTR&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;FIELD&nbsp;|&nbsp;CONSTR&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_bottom"></A>
<!-- ======== END OF BOTTOM NAVBAR ======= -->

<HR>

</BODY>
</HTML>
